<template>
    <div>
        <div class="page-content">
             <!-- INNER PAGE BANNER -->
             <div class="wt-bnr-inr overlay-wraper bg-center" style="background-image:url(/assets/images/banner/2.jpg);">
                <div class="overlay-main site-bg-secondry opacity-07"></div>
                <div class="container">
                    <div class="wt-bnr-inr-entry">
                        <div class="banner-title-outer">
                            <div class="banner-title-name">
                                <h2 class="site-text-primary" style="margin-top: 15%;">
                                {{
                                    lang == 'en' ? 'Calculator' : 'Kalkulator'
                                }}
                                </h2>
                            </div>
                        </div>
                        <!-- BREADCRUMB ROW -->                            
                        
                            <div>
                                <ul class="wt-breadcrumb breadcrumb-style-2">
                                    <li><a href="/">
                                    {{
                                        lang == 'en' ? 'Home' : 'Beranda'
                                    }}
                                    </a></li>
                                    <li>
                                        {{
                                            lang == 'en' ? 'Calculator' : 'Kalkulator' 
                                        }}
                                    </li>
                                </ul>
                            </div>
                        
                        <!-- BREADCRUMB ROW END -->                        
                    </div>
                </div>
            </div>
            <!-- INNER PAGE BANNER END -->
            <div class="section-full   p-t80 p-b50 bg-white">
                <div class="section-content">
                    <div class="container">
                        <div class="card">
                            <div class="card-body">
                                <div class="row">
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <label>{{lang == 'en' ? 'Installed PLN Power' : 'Daya Terpasang PLN'}}</label>
                                            <select v-model="installedPower" class="select2 form-control" style="width: 100%; border: 1px solid black;" id="power-selection">
                                                <option value="" selected disabled>{{lang == 'en' ? 'Choose Installed Power' : 'Pilih daya yang terpasang'}}</option>
                                                <!-- <option value="450">450</option>
                                                <option value="900">900</option> -->
                                                <option value="1300">1.300</option>
                                                <option value="2200">2.200</option>
                                                <option value="3500">3.500</option>
                                                <option value="4400">4.400</option>
                                                <option value="5500">5.500</option>
                                                <option value="6600">6.600</option>
                                                <option value="7700">7.700</option>
                                                <option value="10600">10.600</option>
                                                <option value="11000">11.000</option>
                                                <option value="13200">13.200</option>
                                                <option value="13900">13.900</option>
                                                <option value="16500">16.500</option>
                                                <option value="17000">17.000</option>
                                                <option value="22000">22.000</option>
                                                <option value="23000">23.000</option>
                                                <option value="33000">33.000</option>
                                                <option value="41500">41.500</option>
                                                <option value="53000">53.000</option>
                                                <option value="66000">66.000</option>
                                                <option value="82000">82.000</option>
                                                <option value="105000">105.000</option>
                                                <option value="131000">131.000</option>
                                                <option value="147000">147.000</option>
                                                <option value="164000">164.000</option>
                                                <option value="197000">197.000</option>
                                                <option value="233000">233.000</option>
                                                <option value="279000">279.000</option>
                                                <option value="329000">329.000</option>
                                                <option value="414000">414.000</option>
                                                <option value="526000">526.000</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <label>{{lang == 'en' ? 'Monthly Electricity Bill' : 'Tagihan Listrik Bulanan'}}</label>
                                            <input  class="form-control" style="border: 1px solid black;" type="text" id="rupiah" v-bind:placeholder="lang == 'en' ? 'Monthly Electricity Bill' : 'Tagihan Listrik Bulanan'">
                                        </div>
                                    </div>
                                    <div class="col-md-12">
                                        <button @click.prevent="counter()" class="btn btn-primary pull-right">{{lang == 'en' ? 'Calculate' : 'Menghitung'}}</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="container p-t30" v-if="isCounted && !onLoad">
                        <div class="card ">
                            <div class="card-body">

                                <h5 class="card-title">{{lang == 'en' ? 'Result' : 'Hasil'}}</h5>
                                <div id="no-more-tables">
                                    <table class="table-bordered  table-condensed cf wt-responsive-table shopping-table">
                                        <thead class="cf bg-gray">
                                            
                                            <tr>
                                                <th>{{lang == 'en' ? 'KWH/ Month' : 'KWH/ Bulan'}}</th>
                                                <th class="numeric">{{lang == 'en' ? 'KWH/ Day' : 'KWH/ Hari'}}</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr>
                                                <td v-bind:data-title="lang == 'en' ? 'KWH/ Month' : 'KWH/ Bulan'">{{result.mon.toFixed(2)}}</td>
                                                <td v-bind:data-title="lang == 'en' ? 'KWH/ Day' : 'KWH/ Hari'" class="numeric">{{result.day.toFixed(2)}}</td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </div>

                                <h5 class="card-title">{{lang == 'en' ? 'Recommended System' : 'Rekomendasi Sistem'}}</h5>
                                <div id="no-more-tables">
                                    <table class="table-bordered  table-condensed cf wt-responsive-table shopping-table">
                                        <thead class="cf bg-gray">
                                            
                                            <tr>
                                                <th>{{lang == 'en' ? 'System Power' : 'Daya Sistem'}}</th>
                                                <th class="numeric">{{lang == 'en' ? 'Electricity Production' : 'Produksi Listrik'}}</th>
                                                <th>{{lang == 'en' ? 'System Price' : 'Harga Sistem'}}</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr>
                                                <td v-bind:data-title="lang == 'en' ? 'System Power' : 'Daya Sistem'">{{recom.sr}}</td>
                                                <td v-bind:data-title="lang == 'en' ? 'Electricity Production' : 'Produksi Listrik'" class="numeric">{{recom.prod.toFixed(2)}}</td>
                                                <td v-bind:data-title="lang == 'en' ? 'System Price' : 'Harga Sistem'">{{recom.price}}</td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </div><br>

                                <h5 class="card-title">{{lang == 'en' ? 'Monthly Bill (No Solar)' : 'Tagihan Tiap Bulan (Tidak Menggunakan Tenaga Surya)'}}</h5>
                                
                                <div class="progress">
                                    <div class="progress-bar bg-danger" role="progressbar" style="width: 100%; color: white" aria-valuenow="15" aria-valuemin="0" aria-valuemax="100">Rp. {{bill_numb}}</div>
                                </div><br>

                                <h5 class="card-title">{{lang == 'en' ? 'Monthly Bill (Solar)' : 'Tagihan Tiap Bulan (Dengan Tenaga Surya)'}}</h5>
                                <div class="progress">
                                    <div class="progress-bar bg-danger" role="progressbar" v-bind:style="presen" aria-valuenow="15" aria-valuemin="0" aria-valuemax="100">{{countMon}}</div>
                                    <div class="progress-bar" role="progressbar" v-bind:style="minpersen" aria-valuenow="30" aria-valuemin="0" aria-valuemax="100">{{saving}}</div>
                                  </div>
                                <table>
                                    <tr>
                                        <td style="width: 30px;">
                                            <div style="width: 10px; height: 10px; background-color: red;"></div>
                                        </td>
                                        <td style="padding-left: 10px; width: 20%;">
                                            {{lang == 'en' ? 'Electricity Bill' : 'Tagihan Listrik'}}
                                        </td>
                                        <td style="width: 30px; padding-left: 5px;">
                                            <div style="width: 10px; height: 10px; background-color: #159a32;"></div>
                                        </td>
                                        <td style="padding-left: 10px;">
                                            {{lang == 'en' ? 'Saving' : 'Hemat'}}
                                        </td>
                                    </tr>
                                </table>

                                <h5 class="card-title">{{lang == 'en' ? 'Saving' : 'Penghematan'}}</h5>
                                <div id="no-more-tables">
                                    <table class="table-bordered  table-condensed cf wt-responsive-table shopping-table">
                                        <thead class="cf bg-gray">
                                            <tr>
                                                <th>{{lang == 'en' ? 'Monthly' : 'Perbulan'}}</th>
                                                <th>{{lang == 'en' ? '10 Years' : '10 Tahun'}}</th>
                                                <th>{{lang == 'en' ? '25 Years' : '25 Tahun'}}</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr>
                                                <td v-bind:data-title="lang == 'en' ? 'Monthly' : 'Perbulan'">{{saving}}</td>
                                                <td v-bind:data-title="lang == 'en' ? '10 Years' : '10 Tahun'">{{tensave}}</td>
                                                <td v-bind:data-title="lang == 'en' ? '25 Years' : '25 Tahun'">{{moresave}}</td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </div>
                                
                            </div>
                        </div>
                    </div>
                    <div class="countainer p-t30" v-if="isCounted && onLoad">
                        <div class="p-t40" style="height: 300px;" >
                            <div class="loader" >
                                <span class="block-1"></span>
                                <span class="block-2"></span>
                                <span class="block-3"></span>
                                <span class="block-4"></span>
                                <span class="block-5"></span>
                                <span class="block-6"></span>
                                <span class="block-7"></span>
                                <span class="block-8"></span>
                                <span class="block-9"></span>
                                <span class="block-10"></span>
                                <span class="block-11"></span>
                                <span class="block-12"></span>
                                <span class="block-13"></span>
                                <span class="block-14"></span>
                                <span class="block-15"></span>
                                <span class="block-16"></span>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        data() {
            return {
                onLoad: false,
                lang: 'en',
                bill: null,
                bill_numb: null,
                installedPower: '',
                result: {
                    mon: 0,
                    day: 0
                },
                isCounted: false,
                recom: {
                    sr: 0,
                    prod: 0,
                    price: 'Rp. 1.080.000.000'
                },
                saving: 0,
                tensave: 0,
                moresave: 0,

                presen: '',
                minpersen: '',

                countMon: 0,
                countSave: 0
            }
        },
        mounted() {
            $("html, body").animate({
				scrollTop: 0
			}, 500);
            $("#power-selection").on('change', e => {
                this.installedPower = $("#power-selection").val()
            })
            if(!localStorage.getItem('__LANG') || localStorage.getItem('__LANG') == 'en') {
                this.lang = 'en'
            } else {
                this.lang = 'id'
            }
            let rupiah = document.getElementById('rupiah');
            rupiah.addEventListener('keyup', (e) => {
                // tambahkan 'Rp.' pada saat form di ketik
                // gunakan fungsi formatRupiah() untuk mengubah angka yang di ketik menjadi format angka
                rupiah.value = this.formatInput($("#rupiah").val(), ' ');
                this.bill = this.formatInput($("#rupiah").val(), ' ');
            });
        },
        methods: {
            counter() {
                this.onLoad = true
                let angka = parseInt(this.bill_numb.replace(/[^,\d]/g, ''))
                let tarif = 1467
                if(parseInt(this.installedPower) > 900 && parseInt(this.installedPower) < 197001) {
                    tarif = 1467
                }
                this.result.mon = (angka / tarif) - ((this.installedPower * 40) / 1000)
                this.result.day = ((angka / tarif) - ((this.installedPower * 40) / 1000)) / 30
                let sr = this.result.day / 4.75 * 0.8
                let adj = sr.toFixed(1) * 1000
                let srSize = this.findSize(adj)
                if(srSize > this.installedPower) {
                    this.recom.sr = this.findSize(parseInt(this.installedPower) -100)
                } else {
                    this.recom.sr = srSize
                }

                this.recom.prod = 30*this.recom.sr*4.75 / 1000

                let TempSaving = this.recom.prod * tarif
                let planTemS = TempSaving.toFixed(2).toString().split('.')
                this.saving = planTemS.length > 0 ? this.formatRupiah(planTemS[0])+','+planTemS[1] : this.formatRupiah(TempSaving) ;
                
                planTemS = (angka - TempSaving).toFixed(2).toString().split('.')
                this.countMon = planTemS.length > 0 ? this.formatRupiah(planTemS[0])+','+planTemS[1] : this.formatRupiah((angka - TempSaving))
                

                let temp1 = (this.recom.sr * 0.8 / 1000) * 4.75 * 365
                let tempprice = tarif
                let price = temp1 * tarif
                for (let index = 0; index < 10; index++) {
                    const tp = price
                    if(index != 0) {
                        tempprice = tempprice*(1 + 0.07)
                        price = (tempprice * temp1 ) + tp
                    }
                }
                
                let planParse = price.toFixed(2).toString().split('.')
                this.tensave = planParse.length > 0 ? this.formatRupiah(planParse[0]) +","+planParse[1] : this.formatRupiah(price.toString())

                temp1 = (this.recom.sr * 0.8 / 1000) * 4.75 * 365
                tempprice = tarif
                price = temp1 * tarif
                for (let index = 0; index < 25; index++) {
                    const tp = price
                    if(index != 0) {
                        tempprice = tempprice*(1 + 0.07)
                        price = ((tempprice * temp1 ) + tp)
                    }
                }
                
                planParse = price.toFixed(2).toString().split('.')
                this.moresave = planParse.length > 0 ? this.formatRupiah(planParse[0]) +","+planParse[1] : this.formatRupiah(price.toString())

                let test = angka
                this.presen = `width: ${(angka - TempSaving)/ angka * 100}%; color: white;`
                this.minpersen = `width: ${100 - ((angka - TempSaving)/ angka * 100)}%; color: white;`

                this.isCounted = true
                setTimeout(() => {
                    this.onLoad = false
                }, 1000)
            },
            formatRupiah(angka, prefix){
                var number_string = angka.replace(/[^,\d]/g, '').toString(),
                split   		= number_string.split(','),
                sisa     		= split[0].length % 3,
                rupiah     		= split[0].substr(0, sisa),
                ribuan     		= split[0].substr(sisa).match(/\d{3}/gi);
    
                // tambahkan titik jika yang di input sudah menjadi angka ribuan
                let separator;
                if(ribuan){
                    separator = sisa ? '.' : '';
                    rupiah += separator + ribuan.join('.');
                }
    
                rupiah = split[1] != undefined ? rupiah + ',' + split[1] : rupiah;
                return prefix == undefined ? 'Rp. '+ rupiah : (rupiah ? 'Rp. ' + rupiah : '');
            },

            formatInput(angka, prefix){
                var number_string = angka.replace(/[^,\d]/g, '').toString(),
                split   		= number_string.split(','),
                sisa     		= split[0].length % 3,
                rupiah     		= split[0].substr(0, sisa),
                ribuan     		= split[0].substr(sisa).match(/\d{3}/gi);
    
                // tambahkan titik jika yang di input sudah menjadi angka ribuan
                let separator;
                if(ribuan){
                    separator = sisa ? '.' : '';
                    rupiah += separator + ribuan.join('.');
                }
    
                rupiah = split[1] != undefined ? rupiah + ',' + split[1] : rupiah;
                this.bill_numb =  prefix == undefined ? rupiah : (rupiah ? '' + rupiah : '')
                return prefix == undefined ? rupiah : (rupiah ? '' + rupiah : '');
            },
            

            findSize(adj) {
                if(adj <= 1500) {
                    this.recom.price = this.formatRupiah('23000000')
                    return 1000
                } else if( adj > 1500 && adj <= 2500) {
                    this.recom.price = this.formatRupiah('40000000')
                    return 2000
                } else if(adj > 2500 && adj <= 3500) {
                    this.recom.price = this.formatRupiah('55000000')
                    return 3000
                } else if(adj > 3500 && adj <= 4500) {
                    this.recom.price = this.formatRupiah('75000000')
                    return 4000
                } else if(adj > 4500 && adj <= 5500) {
                    this.recom.price = this.formatRupiah('110000000')
                    return 5000
                } else if(adj > 5500 && adj <= 6500) {
                    this.recom.price = this.formatRupiah('110000000')
                    return 6000
                } else if(adj > 6500 && adj <= 7500) {
                    return 7000
                } else if(adj > 7500 && adj <= 8500) {
                    return 8000
                }else if( adj > 8500 && adj <= 9500) {
                    return 9000
                } else if(adj > 9500 && adj <= 10500) {
                    return 10000
                } else if(adj > 10500 && adj <= 11500) {
                    return 11000
                } else if(adj > 11500 && adj <= 12500) {
                    return 12000
                } else if(adj > 13500 && adj <= 14500) {
                    return 14000
                } else if(adj > 14500 && adj <= 15500) {
                    return 15000
                } else if(adj > 15500 && adj <= 17500) {
                    return 18000
                } else if(adj > 17500 && adj <= 20500) {
                    return 20000
                } else if(adj > 20500 && adj <= 30500) {
                    return 30000
                } else if(adj > 30500 && adj <= 40500) {
                    return 40000
                } else if(adj > 40500 && adj <= 50500) {
                    return 50000
                } else if(adj > 50500 && adj <= 100500) {
                    return 100000
                } else if(adj > 100500) {
                    return 15000
                }
            }

        }
    }
</script>